Skip to main content
`Ctrl`+`K`

# PCFactorSetShiftType

adds a particular type of quantity to the diagonal of the matrix during numerical factorization, thus the matrix has nonzero pivots

## Synopsis

    #include "petscpc.h"
    PetscErrorCode PCFactorSetShiftType(PC pc, MatFactorShiftType shifttype)

Logically Collective

## Input Parameters

- pc - the preconditioner context

- shifttype - type of shift; one of `MAT_SHIFT_NONE`, `MAT_SHIFT_NONZERO`, `MAT_SHIFT_POSITIVE_DEFINITE`, `MAT_SHIFT_INBLOCKS`

## Options Database Key

- -pc_factor_shift_type <shifttype> - Sets shift type; use ‘-help’ for a list of available types

## See Also

KSP: Linear System Solvers, `PCCHOLESKY`, `PCLU`, `PCFactorSetZeroPivot()`, `PCFactorSetShiftAmount()`

## Level

intermediate

## Location

src/ksp/pc/impls/factor/factor.c

## Examples

src/ksp/pc/tutorials/ex1.c
src/ksp/pc/tutorials/ex2.c

## Implementations

PCFactorSetShiftType_Factor() in src/ksp/pc/impls/factor/factimpl.c
PCFactorSetShiftType_Redundant() in src/ksp/pc/impls/redundant/redundant.c

Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages